/**
 * 
 */
package kfmes.jremote.common;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.Serializable;

import javax.imageio.ImageIO;

/**
 * @author kfmes
 *
 */
public class ImageData implements Serializable, Message, Cloneable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1110377895432458141L;
	public transient static final int TYPE_PNG = 0;
	public transient static final int TYPE_JPEG = 1;
	
	private transient int type = TYPE_PNG;
	private transient String imgType = type==0 ? "PNG" : "JPEG";
	private transient Image img = null;
//	private transient int compFactorX = 2;
//	private transient int compFactorY = 5;
	private transient int compFactor = 10;

	public int x;
	public int y;
	public int col;
	public int row;
	
	private byte data[] = null; // TODO: private 로 바꿀것
	private long timestamp = 0;
	private Object tag;
	
	
	public ImageData() {
		
	}
	
	public ImageData(int x, int y, int col, int row, int type) {
		this.x = x;
		this.y = y;
		this.col = col;
		this.row = row;
		this.type = type;
		imgType= type==0 ? "PNG" : "JPEG";
	}
	
	public void setData(BufferedImage img){
		this.img = img;
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		timestamp = System.currentTimeMillis();
		try {
			ImageIO.write(img, imgType, out);
			data = out.toByteArray();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	public byte[] getData(){
		return this.data;
	}
	
	public boolean isInit(){
		return this.data!=null;
	}
	
	
	public Image getImage() {
		if(img!=null)
			return img;
		
		try{
			ByteArrayInputStream bbis = new ByteArrayInputStream(data);
			img = ImageIO.read(bbis);
			bbis.close();
		}catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		data = null;
	
		return img;
	}

	public Object getContent() {
		try{
			return getImage();
		}catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	public int getType() {
		return TYPE_IMGDATA;
	}
	public void setTag(Object tag){
		this.tag = tag;
	}

	public Object getTag() {
		return tag;
	}

	public long getTimeStamp() {
		return timestamp;
	}

	public int getFrom() {
		return FROM_SERVER;
	}
	
	public boolean equals(ImageData imgdata) {
		byte[] data2 = imgdata.data;
		if(imgdata==null || data2!=null)
			return false;
		
//		
//		if(data.length!=data2.length )
//			return false;

		// 성능 문제가 될거 같아 일부만 검사함
		for(int i=0;i<data.length;i+=compFactor){
			if(data[i]!=data2[i]) return false;	
		}
		
			
		
//		if(img.getType()!= img2.getType() ||
//			img.getMinX() != img2.getMinX() ||
//			img.getMinY() != img2.getMinY() ||
//			img.getWidth() != img2.getWidth() ||
//			img.getHeight() != img2.getHeight()
//		)
//			return false;
//		int mx = img.getMinX();
//		int my = img.getMinY();
//		int w = img.getWidth();
//		int h = img.getHeight();
//		
//		
//		for(int y=my ; y< my+h ; y+=compFactorY){
//			for(int x= mx; x< mx+w; x+=compFactorX){
//				if(img.getRGB(x, y)!=img2.getRGB(x, y))
//					return false;
//			}
//		}
		return true;
	}

	public ImageData clone()  {
		try{
			return (ImageData)super.clone();
		}catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		return null;
	}

	

	
}
