/**
 * 
 */
package kfmes.jremote.common;

import java.io.Serializable;
import java.lang.reflect.Array;

/**
 * @author kfmes
 *
 */
public class KeyEvent implements Serializable, Message{
	/**
	 * 
	 */
	private static final long serialVersionUID = 2970826028774892650L;
	public static final int Action_UNKNOWN = 0;
	public static final int Action_KEY_Pressed = 1;
	public static final int Action_KEY_Released = 2;
	
	private int keyCode = 0;
	private int action = Action_UNKNOWN;
	private long timestamp = 0;
	

	public KeyEvent(int keycode, int action) {
		timestamp = System.currentTimeMillis();
		this.keyCode = keycode;
		this.action = action;
	}
	
	@Override
	public Object getContent() {
		return new Integer[] { keyCode, action };
	}

	@Override
	public int getType() {
		return TYPE_KEY_EVENT; 
	}

	@Override
	public Object getTag() {
		return null;
	}

	@Override
	public long getTimeStamp() {
		return timestamp;
	}

	@Override
	public int getFrom() {
		return FROM_CLIENT;
	}
	public static void main(String[] args){
		KeyEvent ke = new KeyEvent(13, Action_KEY_Pressed);
		Object e = ke.getContent();
		System.out.println(Array.get(e, 0));
		System.out.println(Array.get(e, 1));
		
	}

}
