/**
 * 
 */
package kfmes.jremote.common;

import java.awt.Point;
import java.io.Serializable;
import java.lang.reflect.Array;

/**
 * @author kfmes
 *
 */
public class MouseEvent implements Serializable, Message{
	/**
	 * 
	 */
	private static final long serialVersionUID = -6125504690763594969L;

	public static final int Action_UNKNOWN = 0;
	
	public static final int Action_MOUSE_Pressed = 11;
	public static final int Action_MOUSE_Released = 12;
	public static final int Action_MOUSE_Dragged = 13;
	public static final int Action_MOUSE_Moved = 14;
	public static final int Action_MOUSE_WheelMoved = 15;
	
	private Point point =null ;
	private int action = Action_UNKNOWN;
	private int amount = 0;
	private int buttons = 0;
	private long timestamp = 0;
	

	public MouseEvent(Point p , int action) {
		timestamp = System.currentTimeMillis();
		this.point = p;
		this.action = action;
	}
	
	/**
	 * when occur mouse wheel moved
	 * @param p - mouse Point 
	 * @param action - action
	 * @param tag (button code or, wheel amount
	 */
	public MouseEvent(Point p, int action, int tag){
		timestamp = System.currentTimeMillis();
		this.point = p;
		this.action = action;
		if(action==Action_MOUSE_WheelMoved)
			amount = tag;
		else 
			this.buttons = tag;
	}
	
	
	@Override
	public Object getContent(){
		if(action!=Action_MOUSE_WheelMoved)
			return new Object[] { point, action };
		else 	
			return new Object[] { point, action, amount };
	}

	@Override
	public int getType() {
		return TYPE_KEY_EVENT; 
	}

	@Override
	public Object getTag() {
		return null;
	}

	@Override
	public long getTimeStamp() {
		return timestamp;
	}

	@Override
	public int getFrom() {
		return FROM_CLIENT;
	}
	
	public static void main(String[] args){
		MouseEvent me = new  MouseEvent(new Point(12,34), Action_MOUSE_Dragged);
		try {
			Object object = me.getContent();
			Point p = (Point) Array.get(object, 0);
			System.out.println(p);
			
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		
	}

}
