/**
 * 
 */
package kfmes.jremote.common;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Properties;

/**
 * @author kfmes
 *
 */
public class SystemEvent implements Serializable, Message {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1567402366740122635L;
	
	public static final int PeerConnect = 1;
	public static final int PeerDisConnect = 2;
	public static final int ClientSetup = 3;
	
	
	private long timestamp = 0;
//	private int type ; 
	
//	private HashMap<String, String> message;
	private Integer message;
	private HashMap<String, String> tag;
	private int from;
	
	public SystemEvent(Integer msg , /*int type,*/ HashMap<String, String> tag, int from) {
		timestamp = System.currentTimeMillis();
//		this.type = type;
		
		this.message = msg;
		this.tag = tag;
		this.from = from;
		
	}
	
	public Object getContent() {
		return message;
	}

	@Override
	public int getType() {
		return TYPE_SYSEVENT;
	}

	@Override
	public Object getTag() {
		return tag;
	}
	
	public void setTag(HashMap<String, String> tag) {
		this.tag = tag;
	}

	@Override
	public long getTimeStamp() {
		return timestamp;
	}

	@Override
	public int getFrom() {
		return from;
	}
	
	@Override
	public String toString() {
		return "SystemEvent " + 
			(from==FROM_SERVER ? "C->S" : "S-C" ) + getType();  
	}

	
}
