/**
 * 
 */
package kfmes.jremote.net;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.SocketException;

import kfmes.jremote.common.EventListener;
import kfmes.jremote.common.ImageData;
import kfmes.jremote.common.Message;
import kfmes.jremote.common.MouseEvent;
import kfmes.jremote.common.SystemEvent;
import kfmes.jremote.exception.JRemoteException;


/**
 * @author kfmes
 *
 */
public class NetworkHandler extends Thread{
	
	/*
	 * TODO: Send/Reading Queue 를 만들어서, 
	 * Message Queue 방식으로 동작하게 만들어야함 .. 
	 * 우선순위 낮음 . 
	 */
	
	private Socket socket = null;
	
	private ObjectOutputStream objout = null;
	private ObjectInputStream objin = null;
	
	
	private InputStream in = null;
	private OutputStream out = null;
	
	protected EventListener listener = null;
	protected boolean isRunning = true;

	public NetworkHandler(Socket sock) {
		this.socket = sock;
		setName("NetworkHandler:" + hashCode());
		setupNetwork();
	}
	
	private boolean setupNetwork(){
		try{
		in = socket.getInputStream();
		out = socket.getOutputStream();
		objout = new ObjectOutputStream(out);
		
		}catch (Exception e) {
			return false;
		}
		return true;
	}
	
	public void setListener(EventListener listener){
		this.listener = listener;
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
	}


	public void close() throws IOException {
		objin.close();
		objout.close();
		in.close();
		out.close();
		socket.close();		
		
	}


	public void sendObject(Object object) {
//		System.out.println("send" + object);
		try {
//			synchronized (listener) 
			{
				objout.writeObject(object);
				objout.flush();
			}
			
		} catch (IOException e) {
			e.printStackTrace();
			isRunning =false;
		}
	}
	
	public Object readObject() {
		
		Object object = null;
		try {
//			synchronized (listener) 
			{
				object = objin.readObject();				
			}
		
		}catch (NullPointerException e) {
			isRunning = false;
		}catch (SocketException e) {
			System.exit(-1);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return object; 
	}
	
	public NetworkHandler() {
		
	}
	
	private Message parseObject(Object o) throws JRemoteException{
		if (o instanceof Message)
			return (Message) o;
		throw new JRemoteException("Unknown Object");		
	}

	public void run() {
		
//		isRunning = setupNetwork();
		System.out.println("running");
		try{
			objin = new ObjectInputStream(in);
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		while(isRunning){
			try{
				Object o = readObject();
//				Message message = parseObject(o);
				Message message = (Message)o;
//				if(message!=null)
//					System.out.println("read " + o.toString());
				
				if(message.getFrom()==Message.FROM_SERVER){
					// handle from server message
					switch (message.getType()) {
					case Message.TYPE_IMGDATA:
						listener.ImageReceived((ImageData) message);
						break;
					case Message.TYPE_SYSEVENT:
						System.out.println("NetworkHandler.run()");
						listener.SystemEvent((SystemEvent)message);
						break;
					default:
						break;
					}
					
				}else if(message.getFrom()==Message.FROM_CLIENT){
					
					switch (message.getType()) {
					case Message.TYPE_KEY_EVENT:
					
						break;
					case Message.TYPE_MOUSE_EVENT:
						listener.MouseEvent((MouseEvent) message);
						break;
					case Message.TYPE_SYSEVENT:						
						listener.SystemEvent((SystemEvent)message);
						
						break;
					default:
						break;
					}
				}
				
//				
//			}catch (JRemoteException e) {
//				e.printStackTrace();
			}catch (NullPointerException e) {
				System.out.println("null");
//				isRunning = false;
			
			}catch (Exception e) {
				e.printStackTrace();
			}			
			
		}
		
		try{ 
			close(); // 네트워크 연결을 종료한다.
		}catch (Exception e) {
			
		}
	}

	public void terminate() {
		this.isRunning = false;
	}

}
