/***************************************************************************
 * ServerProcess.java
 **************************************************************************/
package kfmes.jremote.server;

import java.awt.AWTException;
import java.awt.Robot;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;

import kfmes.jremote.exception.JRemoteException;
import kfmes.jremote.exception.ServerSocketException;

/**
 * @author kfmes
 * @version $Id: Server.java,v 1.3 2008/08/24 09:43:31 kfmes Exp $
 */
public class Server {
	
	private ServerSocket servSocket = null;
	private Socket socket = null;
	private int port = 8001;
	private boolean isRunning = true;
	private ServerUI ui = null;
	
	private ArrayList<ServerProcess> processes = new ArrayList<ServerProcess>();
	
	private void chkAWT() throws AWTException{
		new Robot();
		
	}
	private void chkNetwork() throws IOException{
		servSocket = new ServerSocket(port);
		servSocket.setSoTimeout(10 );
		servSocket.close();
		
	}

	public Server() throws Exception {
		chkAWT();
		chkNetwork();
		
	}
	
	public void start() throws JRemoteException{
		listen();
	}
	private void listen() throws JRemoteException{
		if(servSocket==null)
			throw new ServerSocketException();
		try{
			servSocket = new ServerSocket(port);
		}catch (Exception e) {
			throw new ServerSocketException(e.getMessage(), e);
		}
		
		while(isRunning){
			
			try {
				socket = servSocket.accept();
				System.out.println("new client connected");
				if(processes.size()<1){
					ServerProcess sproc = new ServerProcess(socket, this);
					processes.add(sproc);
				}
				//new ServerProcess(socket);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		
	}
	
	
	public void terminate() {
		//TODO: 종료 코드 here 
		for(ServerProcess sp : processes)
			sp.terminate();
		
		try{
			Thread.sleep(2000); // process 들이 죽을때까지 2초정도 기다린다.
		}catch (Exception e) {
			e.printStackTrace();
		}
			
		
		
	}
	
	public static void main(String[] args) throws Exception{
		Server server = new Server();
		server.start();		
	}
	
}
