/***************************************************************************
 * ServerUI.java
 **************************************************************************/
package kfmes.jremote.server;

import java.awt.Rectangle;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

import kfmes.jremote.client.Screen;
import kfmes.jremote.common.ImageData;

/**
 * @author kfmes
 * @version $Id: ServerUI.java,v 1.1 2008/08/08 07:42:32 kfmes Exp $
 */
public class ServerUI extends JFrame {
	private Server main = null;
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JButton btn_end = null;
	private JFrame testFrame = null;
	private Screen testScreen  = null;
	private ServerProcess process;

	/**
	 * This method initializes btn_end	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtn_end() {
		if (btn_end == null) {
			btn_end = new JButton();
			btn_end.setBounds(new Rectangle(186, 120, 97, 44));
			btn_end.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					main.terminate();
				}
			});
		}
		return btn_end;
	}


	/**
	 * @param args
	 */
	public static void main(String[] args) {

				ServerUI thisClass = new ServerUI(null);
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
	}

	/**
	 * This is the default constructor
	 */
	public ServerUI(Server mainapp) {
		super();
		this.main = mainapp;
		initialize();
	}
	
	public void setProcess(ServerProcess sp)
	{
		this.process =sp;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
		
		testFrame = new JFrame("TEST");
		testFrame.setSize(800,600);
		
		testScreen = getTestScreen();
		testFrame.add(testScreen);
		testFrame.setVisible(true);
	}
	
	private Screen getTestScreen(){
		Screen scr = new Screen();
		
		return scr;
	}
	protected void setScreenSize(){
		testScreen.setSize(process.rect.width, process.rect.height, process.blockX, process.blockY);
	}
	protected void drawScreenTest(ImageData img){
		testScreen.setImage(img);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getBtn_end(), null);
		}
		return jContentPane;
	}

}
