/**
 * 
 */
package kfmes.jremote.test;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

import kfmes.jremote.common.ImageData;

/**
 * @author kfmes
 *
 */
public class ImageTest extends JFrame {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;

	
	private Robot bot = null;

	protected BufferedImage screen = null;
	protected Rectangle rect;
	protected int pixels[] = null;
	protected ImageData rscreen = null;  //  @jve:decl-index=0:
	
	private Toolkit t  = Toolkit.getDefaultToolkit();
	private Dimension d = t.getScreenSize();
	private JButton jButton = null;

	
	
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(new Rectangle(9, 6, 72, 42));
			jButton.setText("Test");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					save();
					load();
					repaint();
					
				}
			});
		}
		return jButton;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				ImageTest thisClass = new ImageTest();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public ImageTest() {
		super();
		initialize();

		System.out.println(d);
		try{
			bot = new Robot();
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		rect = new Rectangle( d.width/2, d.height/2);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(1000, 800);
		this.setContentPane(getJContentPane());
		this.setTitle("Testing");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJButton(), null);
			
		}
		return jContentPane;
	}
	
	
	private void save(){
		//if(screen ==null){
			screen = bot.createScreenCapture(rect);
			pixels = new int[(d.height) * (d.width)];
		//}
//		screen.getRGB(0, 0, rect.width, rect.height, pixels, 0, rect.width);
		ImageData data = new ImageData();
		data.setData(screen);
		
		
		try {
			ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("out.data"));
			out.writeObject(data);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
	}
	private void load(){
		
		try{
			ObjectInputStream in = new ObjectInputStream(new FileInputStream("out.data"));
			rscreen = (ImageData) in.readObject();
			
		}catch (Exception e) {
			e.printStackTrace();
		}

	}
	/**
	 * 
	 */
	private void display(){
		
	}
	
	
	
	
	class JPanel extends javax.swing.JPanel{
		@Override
		public void paint(Graphics g) {
			super.paint(g);
			
			if(rscreen!=null){			
				try{
					g.drawImage(rscreen.getImage(), 0, 100, this);
				}catch (Exception e) {
					e.getMessage();
				}
			}
			else {
				Font f = g.getFont();
				Font nf = new Font(f.getFontName(), f.getStyle(), 30);
				
				g.setFont(nf);
				g.drawString("blank", 100,100);
				g.setFont(f);
				
			}
			
		}
		
		
	}

}
